/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in a specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.sim;

import java.util.Map;
import java.util.HashMap;
import ru.ispras.microtesk.model.api.memory.MemoryDevice;
import ru.ispras.microtesk.mmu.model.api.*;

/**
 * The {@code Model} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */

public final class Model implements MmuModel {
  private final Map<String, BufferObserver> buffers;
  private final Map<String, MemoryDevice> memories;

  public Model() {
    this.buffers = newBuffers();
    this.memories = newMemories();
  }

  private static Map<String, BufferObserver> newBuffers() {
    final Map<String, BufferObserver> result = new HashMap<>();
    result.put("L1", L1.get());
    result.put("L2", L2.get());
    result.put("Memory", Memory.get());
    result.put("SEG", SEG.get());
    return result;
  }

  private static Map<String, MemoryDevice> newMemories() {
    final Map<String, MemoryDevice> result = new HashMap<>();
    result.put("pmem", new pmem());
    return result;
  }

  @Override
  public BufferObserver getBufferObserver(final String bufferId) {
    return buffers.get(bufferId);
  }

  @Override
  public MemoryDevice getMemoryAccessor(final String deviceId) {
    return memories.get(deviceId);
  }
}
