/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in a specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.sim;

import ru.ispras.microtesk.mmu.model.api.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code pmem} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */

public final class pmem extends ru.ispras.microtesk.mmu.model.api.Memory<VA> {
  @Override
  public int getAddressBitSize() {
    return 32;
  }

  @Override
  public int getDataBitSize() {
    return 32;
  }

  @Override
  protected VA newAddress() {
    return new VA();
  }

  @Override
  public BitVector getData(final VA va) {
    final BitVector data = BitVector.newEmpty(32);

    final BitVector c = BitVector.newEmpty(3);
    final L1.Entry l1Entry = new L1.Entry();
    final L2.Entry l2Entry = new L2.Entry();
    final PA pa = new PA();
    final BitVector cacheData = BitVector.newEmpty(256);

    c.assign(BitVector.valueOf(0x03, 3));
    pa.value.assign(va.value);
    if (!c.field(1, 0).equals(BitVector.valueOf(0x02, 2))) {
      if (L1.get().isHit(pa)) {
        l1Entry.assign(L1.get().getData(pa));
        cacheData.assign(l1Entry.DATA);
        data.assign(cacheData.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))));
      } else {
        if (c.field(1, 0).equals(BitVector.valueOf(0x03, 2))) {
          if (L2.get().isHit(pa)) {
            l2Entry.assign(L2.get().getData(pa));
            cacheData.assign(l2Entry.DATA);
            data.assign(cacheData.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))));
            l1Entry.V.assign(BitVector.valueOf(0x01, 1));
            l1Entry.TAG.assign(pa.value.field(31, 12));
            l1Entry.DATA.assign(cacheData);
            L1.get().setData(pa).assign(l1Entry);
          } else {
            cacheData.assign(Memory.get().getData(pa).asBitVector());
            data.assign(cacheData.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))));
            l2Entry.V.assign(BitVector.valueOf(0x01, 1));
            l2Entry.TAG.assign(pa.value.field(31, 17));
            l2Entry.DATA.assign(cacheData);
            L2.get().setData(pa).assign(l2Entry);
            l1Entry.V.assign(BitVector.valueOf(0x01, 1));
            l1Entry.TAG.assign(pa.value.field(31, 12));
            l1Entry.DATA.assign(cacheData);
            L1.get().setData(pa).assign(l1Entry);
          }
        } else {
          cacheData.assign(Memory.get().getData(pa).asBitVector());
          data.assign(cacheData.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))));
          l1Entry.V.assign(BitVector.valueOf(0x01, 1));
          l1Entry.TAG.assign(pa.value.field(31, 12));
          l1Entry.DATA.assign(cacheData);
          L1.get().setData(pa).assign(l1Entry);
        }
      }
    } else {
      cacheData.assign(Memory.get().getData(pa).asBitVector());
      data.assign(cacheData.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))));
    }

    return data;
  }

  @Override
  public BitVector setData(final VA va, final BitVector data) {
    final BitVector c = BitVector.newEmpty(3);
    final L1.Entry l1Entry = new L1.Entry();
    final L2.Entry l2Entry = new L2.Entry();
    final PA pa = new PA();
    final BitVector cacheData = BitVector.newEmpty(256);

    c.assign(BitVector.valueOf(0x03, 3));
    pa.value.assign(va.value);
    if (!c.field(1, 0).equals(BitVector.valueOf(0x02, 2))) {
      if (L1.get().isHit(pa)) {
        l1Entry.assign(L1.get().getData(pa));
        l1Entry.DATA.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))).assign(data);
        L1.get().setData(pa).assign(l1Entry);
        Memory.get().setData(pa).assign(l1Entry.DATA);
      } else {
        if (c.field(1, 0).equals(BitVector.valueOf(0x03, 2))) {
          if (L2.get().isHit(pa)) {
            l2Entry.assign(L2.get().getData(pa));
            l2Entry.DATA.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))).assign(data);
            L2.get().setData(pa).assign(l2Entry);
            l1Entry.V.assign(BitVector.valueOf(0x01, 1));
            l1Entry.TAG.assign(pa.value.field(31, 12));
            l1Entry.DATA.assign(l2Entry.DATA);
            L1.get().setData(pa).assign(l1Entry);
            Memory.get().setData(pa).assign(l1Entry.DATA);
          } else {
            cacheData.assign(Memory.get().getData(pa).asBitVector());
            cacheData.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))).assign(data);
            Memory.get().setData(pa).assign(cacheData);
            l2Entry.V.assign(BitVector.valueOf(0x01, 1));
            l2Entry.TAG.assign(pa.value.field(31, 17));
            l2Entry.DATA.assign(cacheData);
            L2.get().setData(pa).assign(l2Entry);
            l1Entry.V.assign(BitVector.valueOf(0x01, 1));
            l1Entry.TAG.assign(pa.value.field(31, 12));
            l1Entry.DATA.assign(cacheData);
            L1.get().setData(pa).assign(l1Entry);
          }
        } else {
          cacheData.assign(Memory.get().getData(pa).asBitVector());
          cacheData.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))).assign(data);
          Memory.get().setData(pa).assign(cacheData);
          l1Entry.V.assign(BitVector.valueOf(0x01, 1));
          l1Entry.TAG.assign(pa.value.field(31, 12));
          l1Entry.DATA.assign(cacheData);
          L1.get().setData(pa).assign(l1Entry);
        }
      }
    } else {
      cacheData.assign(Memory.get().getData(pa).asBitVector());
      cacheData.field(BitVectorMath.add(BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0)), BitVector.valueOf(0x1F, 5)), BitVectorMath.mul(BitVector.valueOf(0x08, 5), pa.value.field(4, 0))).assign(data);
      Memory.get().setData(pa).assign(cacheData);
    }

    return null;
  }
}
