/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in a specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.spec;

import java.util.Collections;
import java.util.Collection;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBuffer;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuStruct;

/**
 * The {@code L1} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */

public final class L1 extends MmuBuffer {
  private static L1 INSTANCE = null;

  public static L1 get() {
    if (null == INSTANCE) {
      INSTANCE = new L1();
    }
    return INSTANCE;
  }

  public final PA pa = PA.get();

  public static final class Entry extends MmuStruct {
    public final IntegerVariable V;
    public final IntegerVariable TAG;
    public final IntegerVariable DATA;

    public Entry(final String name) {
      super(name);

      this.V = new IntegerVariable(name + ".V", 1);
      this.TAG = new IntegerVariable(name + ".TAG", 20);
      this.DATA = new IntegerVariable(name + ".DATA", 256);

      addField(V);
      addField(TAG);
      addField(DATA);
    }
  }

  public final IntegerVariable V;
  public final IntegerVariable TAG;
  public final IntegerVariable DATA;

  private final Collection<MmuBinding> matchBindings;

  @Override
  public Collection<MmuBinding> getMatchBindings() {
    return matchBindings;
  }

  private L1() {
    this("L1");
  }

  private L1(final String name) {
    super(
        name,
        4L,
        128L,
        PA.get(),
        MmuExpression.var(PA.get().value, 12, 31),
        MmuExpression.var(PA.get().value, 5, 11),
        MmuExpression.var(PA.get().value, 0, 4),
        Collections.<MmuBinding>emptyList(),
        null,
        null,
        true,
        null
    );

    this.V = new IntegerVariable(name + ".V", 1);
    this.TAG = new IntegerVariable(name + ".TAG", 20);
    this.DATA = new IntegerVariable(name + ".DATA", 256);

    addField(V);
    addField(TAG);
    addField(DATA);

    this.matchBindings = Arrays.<MmuBinding>asList(
        new MmuBinding(V, new BigInteger("1", 10)),
        new MmuBinding(TAG, PA.get().value.field(12, 31)));
  }
}
