/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in a specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.spec;

import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.basis.MemoryOperation;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuAction;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuCondition;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuConditionAtom;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuGuard;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSegment;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuTransition;

/**
 * The {@code pmem} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */

public final class pmem {
  private static pmem INSTANCE = null;

  public static pmem get() {
    if (null == INSTANCE) {
      INSTANCE = new pmem();
    }
    return INSTANCE;
  }

  public final VA va = VA.get();
  public final PA pa = PA.get();

  public final IntegerVariable data;
  public final IntegerVariable c;
  public final L1.Entry l1Entry;
  public final L2.Entry l2Entry;
  public final IntegerVariable cacheData;

  public final MmuAction START;
  public final MmuAction STOP;

  public final MmuAction IF_READ;
  public final MmuAction ASSIGN_0;
  public final MmuAction ASSIGN_1;
  public final MmuAction BRANCH_0;
  public final MmuAction BRANCH_1;
  public final MmuAction ASSIGN_2;
  public final MmuAction ASSIGN_3;
  public final MmuAction JOIN_0;
  public final MmuAction BRANCH_2;
  public final MmuAction BRANCH_3;
  public final MmuAction BRANCH_4;
  public final MmuAction ASSIGN_4;
  public final MmuAction ASSIGN_5;
  public final MmuAction ASSIGN_6;
  public final MmuAction ASSIGN_7;
  public final MmuAction ASSIGN_8;
  public final MmuAction ASSIGN_9;
  public final MmuAction JOIN_1;
  public final MmuAction BRANCH_5;
  public final MmuAction ASSIGN_10;
  public final MmuAction ASSIGN_11;
  public final MmuAction ASSIGN_12;
  public final MmuAction ASSIGN_13;
  public final MmuAction ASSIGN_14;
  public final MmuAction ASSIGN_15;
  public final MmuAction ASSIGN_16;
  public final MmuAction ASSIGN_17;
  public final MmuAction ASSIGN_18;
  public final MmuAction JOIN_2;
  public final MmuAction BRANCH_6;
  public final MmuAction ASSIGN_19;
  public final MmuAction ASSIGN_20;
  public final MmuAction ASSIGN_21;
  public final MmuAction ASSIGN_22;
  public final MmuAction ASSIGN_23;
  public final MmuAction JOIN_3;
  public final MmuAction BRANCH_7;
  public final MmuAction ASSIGN_24;

  public final MmuAction IF_WRITE;
  public final MmuAction ASSIGN_25;
  public final MmuAction ASSIGN_26;
  public final MmuAction BRANCH_8;
  public final MmuAction BRANCH_9;
  public final MmuAction ASSIGN_27;
  public final MmuAction ASSIGN_28;
  public final MmuAction ASSIGN_29;
  public final MmuAction JOIN_4;
  public final MmuAction BRANCH_10;
  public final MmuAction BRANCH_11;
  public final MmuAction BRANCH_12;
  public final MmuAction ASSIGN_30;
  public final MmuAction ASSIGN_31;
  public final MmuAction ASSIGN_32;
  public final MmuAction ASSIGN_33;
  public final MmuAction ASSIGN_34;
  public final MmuAction ASSIGN_35;
  public final MmuAction ASSIGN_36;
  public final MmuAction JOIN_5;
  public final MmuAction BRANCH_13;
  public final MmuAction ASSIGN_37;
  public final MmuAction ASSIGN_38;
  public final MmuAction ASSIGN_39;
  public final MmuAction ASSIGN_40;
  public final MmuAction ASSIGN_41;
  public final MmuAction ASSIGN_42;
  public final MmuAction ASSIGN_43;
  public final MmuAction ASSIGN_44;
  public final MmuAction ASSIGN_45;
  public final MmuAction ASSIGN_46;
  public final MmuAction JOIN_6;
  public final MmuAction BRANCH_14;
  public final MmuAction ASSIGN_47;
  public final MmuAction ASSIGN_48;
  public final MmuAction ASSIGN_49;
  public final MmuAction ASSIGN_50;
  public final MmuAction ASSIGN_51;
  public final MmuAction ASSIGN_52;
  public final MmuAction JOIN_7;
  public final MmuAction BRANCH_15;
  public final MmuAction ASSIGN_53;
  public final MmuAction ASSIGN_54;

  private pmem() {
    this("pmem");
  }

  private pmem(final String name) {
    this.data = new IntegerVariable(name + ".data", 32);
    this.c = new IntegerVariable(name + ".c", 3);
    this.l1Entry = new L1.Entry(name + ".l1Entry");
    this.l2Entry = new L2.Entry(name + ".l2Entry");
    this.cacheData = new IntegerVariable(name + ".cacheData", 256);

    this.START = new MmuAction("pmem.START");
    this.STOP = new MmuAction("pmem.STOP");

    this.IF_READ = new MmuAction("pmem.IF_READ");
    this.ASSIGN_0 = new MmuAction("pmem.ASSIGN_0", new MmuBinding(c, new BigInteger("3", 10)));
    this.ASSIGN_1 = new MmuAction("pmem.ASSIGN_1", new MmuBinding(pa.value, va.value));
    this.BRANCH_0 = new MmuAction("pmem.BRANCH_0");
    this.BRANCH_1 = new MmuAction("pmem.BRANCH_1");
    this.ASSIGN_2 = new MmuAction("pmem.ASSIGN_2", l1Entry, L1.get());
    this.ASSIGN_3 = new MmuAction("pmem.ASSIGN_3", new MmuBinding(cacheData, l1Entry.DATA));
    this.JOIN_0 = new MmuAction("pmem.JOIN_0");
    this.BRANCH_2 = new MmuAction("pmem.BRANCH_2");
    this.BRANCH_3 = new MmuAction("pmem.BRANCH_3");
    this.BRANCH_4 = new MmuAction("pmem.BRANCH_4");
    this.ASSIGN_4 = new MmuAction("pmem.ASSIGN_4", l2Entry, L2.get());
    this.ASSIGN_5 = new MmuAction("pmem.ASSIGN_5", new MmuBinding(cacheData, l2Entry.DATA));
    this.ASSIGN_6 = new MmuAction("pmem.ASSIGN_6", new MmuBinding(l1Entry.V, new BigInteger("1", 10)));
    this.ASSIGN_7 = new MmuAction("pmem.ASSIGN_7", new MmuBinding(l1Entry.TAG, pa.value.field(12, 31)));
    this.ASSIGN_8 = new MmuAction("pmem.ASSIGN_8", new MmuBinding(l1Entry.DATA, cacheData));
    this.ASSIGN_9 = new MmuAction("pmem.ASSIGN_9", L1.get() /* no bindings for write */);
    this.JOIN_1 = new MmuAction("pmem.JOIN_1");
    this.BRANCH_5 = new MmuAction("pmem.BRANCH_5");
    this.ASSIGN_10 = new MmuAction("pmem.ASSIGN_10", Memory.get(), new MmuBinding(cacheData, Memory.get().DATA));
    this.ASSIGN_11 = new MmuAction("pmem.ASSIGN_11", new MmuBinding(l2Entry.V, new BigInteger("1", 10)));
    this.ASSIGN_12 = new MmuAction("pmem.ASSIGN_12", new MmuBinding(l2Entry.TAG, pa.value.field(17, 31)));
    this.ASSIGN_13 = new MmuAction("pmem.ASSIGN_13", new MmuBinding(l2Entry.DATA, cacheData));
    this.ASSIGN_14 = new MmuAction("pmem.ASSIGN_14", L2.get() /* no bindings for write */);
    this.ASSIGN_15 = new MmuAction("pmem.ASSIGN_15", new MmuBinding(l1Entry.V, new BigInteger("1", 10)));
    this.ASSIGN_16 = new MmuAction("pmem.ASSIGN_16", new MmuBinding(l1Entry.TAG, pa.value.field(12, 31)));
    this.ASSIGN_17 = new MmuAction("pmem.ASSIGN_17", new MmuBinding(l1Entry.DATA, cacheData));
    this.ASSIGN_18 = new MmuAction("pmem.ASSIGN_18", L1.get() /* no bindings for write */);
    this.JOIN_2 = new MmuAction("pmem.JOIN_2");
    this.BRANCH_6 = new MmuAction("pmem.BRANCH_6");
    this.ASSIGN_19 = new MmuAction("pmem.ASSIGN_19", Memory.get(), new MmuBinding(cacheData, Memory.get().DATA));
    this.ASSIGN_20 = new MmuAction("pmem.ASSIGN_20", new MmuBinding(l1Entry.V, new BigInteger("1", 10)));
    this.ASSIGN_21 = new MmuAction("pmem.ASSIGN_21", new MmuBinding(l1Entry.TAG, pa.value.field(12, 31)));
    this.ASSIGN_22 = new MmuAction("pmem.ASSIGN_22", new MmuBinding(l1Entry.DATA, cacheData));
    this.ASSIGN_23 = new MmuAction("pmem.ASSIGN_23", L1.get() /* no bindings for write */);
    this.JOIN_3 = new MmuAction("pmem.JOIN_3");
    this.BRANCH_7 = new MmuAction("pmem.BRANCH_7");
    this.ASSIGN_24 = new MmuAction("pmem.ASSIGN_24", Memory.get(), new MmuBinding(cacheData, Memory.get().DATA));

    this.IF_WRITE = new MmuAction("pmem.IF_WRITE");
    this.ASSIGN_25 = new MmuAction("pmem.ASSIGN_25", new MmuBinding(c, new BigInteger("3", 10)));
    this.ASSIGN_26 = new MmuAction("pmem.ASSIGN_26", new MmuBinding(pa.value, va.value));
    this.BRANCH_8 = new MmuAction("pmem.BRANCH_8");
    this.BRANCH_9 = new MmuAction("pmem.BRANCH_9");
    this.ASSIGN_27 = new MmuAction("pmem.ASSIGN_27", l1Entry, L1.get());
    this.ASSIGN_28 = new MmuAction("pmem.ASSIGN_28", L1.get() /* no bindings for write */);
    this.ASSIGN_29 = new MmuAction("pmem.ASSIGN_29", Memory.get(), new MmuBinding(Memory.get().DATA, l1Entry.DATA));
    this.JOIN_4 = new MmuAction("pmem.JOIN_4");
    this.BRANCH_10 = new MmuAction("pmem.BRANCH_10");
    this.BRANCH_11 = new MmuAction("pmem.BRANCH_11");
    this.BRANCH_12 = new MmuAction("pmem.BRANCH_12");
    this.ASSIGN_30 = new MmuAction("pmem.ASSIGN_30", l2Entry, L2.get());
    this.ASSIGN_31 = new MmuAction("pmem.ASSIGN_31", L2.get() /* no bindings for write */);
    this.ASSIGN_32 = new MmuAction("pmem.ASSIGN_32", new MmuBinding(l1Entry.V, new BigInteger("1", 10)));
    this.ASSIGN_33 = new MmuAction("pmem.ASSIGN_33", new MmuBinding(l1Entry.TAG, pa.value.field(12, 31)));
    this.ASSIGN_34 = new MmuAction("pmem.ASSIGN_34", new MmuBinding(l1Entry.DATA, l2Entry.DATA));
    this.ASSIGN_35 = new MmuAction("pmem.ASSIGN_35", L1.get() /* no bindings for write */);
    this.ASSIGN_36 = new MmuAction("pmem.ASSIGN_36", Memory.get(), new MmuBinding(Memory.get().DATA, l1Entry.DATA));
    this.JOIN_5 = new MmuAction("pmem.JOIN_5");
    this.BRANCH_13 = new MmuAction("pmem.BRANCH_13");
    this.ASSIGN_37 = new MmuAction("pmem.ASSIGN_37", Memory.get(), new MmuBinding(cacheData, Memory.get().DATA));
    this.ASSIGN_38 = new MmuAction("pmem.ASSIGN_38", Memory.get(), new MmuBinding(Memory.get().DATA, cacheData));
    this.ASSIGN_39 = new MmuAction("pmem.ASSIGN_39", new MmuBinding(l2Entry.V, new BigInteger("1", 10)));
    this.ASSIGN_40 = new MmuAction("pmem.ASSIGN_40", new MmuBinding(l2Entry.TAG, pa.value.field(17, 31)));
    this.ASSIGN_41 = new MmuAction("pmem.ASSIGN_41", new MmuBinding(l2Entry.DATA, cacheData));
    this.ASSIGN_42 = new MmuAction("pmem.ASSIGN_42", L2.get() /* no bindings for write */);
    this.ASSIGN_43 = new MmuAction("pmem.ASSIGN_43", new MmuBinding(l1Entry.V, new BigInteger("1", 10)));
    this.ASSIGN_44 = new MmuAction("pmem.ASSIGN_44", new MmuBinding(l1Entry.TAG, pa.value.field(12, 31)));
    this.ASSIGN_45 = new MmuAction("pmem.ASSIGN_45", new MmuBinding(l1Entry.DATA, cacheData));
    this.ASSIGN_46 = new MmuAction("pmem.ASSIGN_46", L1.get() /* no bindings for write */);
    this.JOIN_6 = new MmuAction("pmem.JOIN_6");
    this.BRANCH_14 = new MmuAction("pmem.BRANCH_14");
    this.ASSIGN_47 = new MmuAction("pmem.ASSIGN_47", Memory.get(), new MmuBinding(cacheData, Memory.get().DATA));
    this.ASSIGN_48 = new MmuAction("pmem.ASSIGN_48", Memory.get(), new MmuBinding(Memory.get().DATA, cacheData));
    this.ASSIGN_49 = new MmuAction("pmem.ASSIGN_49", new MmuBinding(l1Entry.V, new BigInteger("1", 10)));
    this.ASSIGN_50 = new MmuAction("pmem.ASSIGN_50", new MmuBinding(l1Entry.TAG, pa.value.field(12, 31)));
    this.ASSIGN_51 = new MmuAction("pmem.ASSIGN_51", new MmuBinding(l1Entry.DATA, cacheData));
    this.ASSIGN_52 = new MmuAction("pmem.ASSIGN_52", L1.get() /* no bindings for write */);
    this.JOIN_7 = new MmuAction("pmem.JOIN_7");
    this.BRANCH_15 = new MmuAction("pmem.BRANCH_15");
    this.ASSIGN_53 = new MmuAction("pmem.ASSIGN_53", Memory.get(), new MmuBinding(cacheData, Memory.get().DATA));
    this.ASSIGN_54 = new MmuAction("pmem.ASSIGN_54", Memory.get(), new MmuBinding(Memory.get().DATA, cacheData));
  }

  public void preregisterControlFlow(final MmuSubsystem.Builder builder) {
    builder.registerAction(START);
    builder.registerAction(STOP);
  }

  public void registerControlFlow(final MmuSubsystem.Builder builder) {
    builder.registerVariable(c);
    builder.registerVariable(l1Entry);
    builder.registerVariable(l2Entry);
    builder.registerVariable(cacheData);

    builder.registerAction(IF_READ);
    builder.registerAction(ASSIGN_0);
    builder.registerAction(ASSIGN_1);
    builder.registerAction(BRANCH_0);
    builder.registerAction(BRANCH_1);
    builder.registerAction(ASSIGN_2);
    builder.registerAction(ASSIGN_3);
    builder.registerAction(JOIN_0);
    builder.registerAction(BRANCH_2);
    builder.registerAction(BRANCH_3);
    builder.registerAction(BRANCH_4);
    builder.registerAction(ASSIGN_4);
    builder.registerAction(ASSIGN_5);
    builder.registerAction(ASSIGN_6);
    builder.registerAction(ASSIGN_7);
    builder.registerAction(ASSIGN_8);
    builder.registerAction(ASSIGN_9);
    builder.registerAction(JOIN_1);
    builder.registerAction(BRANCH_5);
    builder.registerAction(ASSIGN_10);
    builder.registerAction(ASSIGN_11);
    builder.registerAction(ASSIGN_12);
    builder.registerAction(ASSIGN_13);
    builder.registerAction(ASSIGN_14);
    builder.registerAction(ASSIGN_15);
    builder.registerAction(ASSIGN_16);
    builder.registerAction(ASSIGN_17);
    builder.registerAction(ASSIGN_18);
    builder.registerAction(JOIN_2);
    builder.registerAction(BRANCH_6);
    builder.registerAction(ASSIGN_19);
    builder.registerAction(ASSIGN_20);
    builder.registerAction(ASSIGN_21);
    builder.registerAction(ASSIGN_22);
    builder.registerAction(ASSIGN_23);
    builder.registerAction(JOIN_3);
    builder.registerAction(BRANCH_7);
    builder.registerAction(ASSIGN_24);
    builder.registerAction(IF_WRITE);
    builder.registerAction(ASSIGN_25);
    builder.registerAction(ASSIGN_26);
    builder.registerAction(BRANCH_8);
    builder.registerAction(BRANCH_9);
    builder.registerAction(ASSIGN_27);
    builder.registerAction(ASSIGN_28);
    builder.registerAction(ASSIGN_29);
    builder.registerAction(JOIN_4);
    builder.registerAction(BRANCH_10);
    builder.registerAction(BRANCH_11);
    builder.registerAction(BRANCH_12);
    builder.registerAction(ASSIGN_30);
    builder.registerAction(ASSIGN_31);
    builder.registerAction(ASSIGN_32);
    builder.registerAction(ASSIGN_33);
    builder.registerAction(ASSIGN_34);
    builder.registerAction(ASSIGN_35);
    builder.registerAction(ASSIGN_36);
    builder.registerAction(JOIN_5);
    builder.registerAction(BRANCH_13);
    builder.registerAction(ASSIGN_37);
    builder.registerAction(ASSIGN_38);
    builder.registerAction(ASSIGN_39);
    builder.registerAction(ASSIGN_40);
    builder.registerAction(ASSIGN_41);
    builder.registerAction(ASSIGN_42);
    builder.registerAction(ASSIGN_43);
    builder.registerAction(ASSIGN_44);
    builder.registerAction(ASSIGN_45);
    builder.registerAction(ASSIGN_46);
    builder.registerAction(JOIN_6);
    builder.registerAction(BRANCH_14);
    builder.registerAction(ASSIGN_47);
    builder.registerAction(ASSIGN_48);
    builder.registerAction(ASSIGN_49);
    builder.registerAction(ASSIGN_50);
    builder.registerAction(ASSIGN_51);
    builder.registerAction(ASSIGN_52);
    builder.registerAction(JOIN_7);
    builder.registerAction(BRANCH_15);
    builder.registerAction(ASSIGN_53);
    builder.registerAction(ASSIGN_54);

    builder.registerTransition(new MmuTransition(START, IF_READ, new MmuGuard(MemoryOperation.LOAD)));
    builder.registerTransition(new MmuTransition(IF_READ, ASSIGN_0));
    builder.registerTransition(new MmuTransition(ASSIGN_0, ASSIGN_1));
    builder.registerTransition(new MmuTransition(ASSIGN_1, BRANCH_0, new MmuGuard(MmuConditionAtom.neq(c.field(0, 1), new BigInteger("2", 10)))));
    builder.registerTransition(new MmuTransition(BRANCH_0, BRANCH_1, new MmuGuard(L1.get(), BufferAccessEvent.HIT)));
    builder.registerTransition(new MmuTransition(BRANCH_1, ASSIGN_2));
    builder.registerTransition(new MmuTransition(ASSIGN_2, ASSIGN_3));
    builder.registerTransition(new MmuTransition(ASSIGN_3, JOIN_0));
    builder.registerTransition(new MmuTransition(BRANCH_0, BRANCH_2, new MmuGuard(L1.get(), BufferAccessEvent.MISS)));
    builder.registerTransition(new MmuTransition(BRANCH_2, BRANCH_3, new MmuGuard(MmuConditionAtom.eq(c.field(0, 1), new BigInteger("3", 10)))));
    builder.registerTransition(new MmuTransition(BRANCH_3, BRANCH_4, new MmuGuard(L2.get(), BufferAccessEvent.HIT)));
    builder.registerTransition(new MmuTransition(BRANCH_4, ASSIGN_4));
    builder.registerTransition(new MmuTransition(ASSIGN_4, ASSIGN_5));
    builder.registerTransition(new MmuTransition(ASSIGN_5, ASSIGN_6));
    builder.registerTransition(new MmuTransition(ASSIGN_6, ASSIGN_7));
    builder.registerTransition(new MmuTransition(ASSIGN_7, ASSIGN_8));
    builder.registerTransition(new MmuTransition(ASSIGN_8, ASSIGN_9));
    builder.registerTransition(new MmuTransition(ASSIGN_9, JOIN_1));
    builder.registerTransition(new MmuTransition(BRANCH_3, BRANCH_5, new MmuGuard(L2.get(), BufferAccessEvent.MISS)));
    builder.registerTransition(new MmuTransition(BRANCH_5, ASSIGN_10));
    builder.registerTransition(new MmuTransition(ASSIGN_10, ASSIGN_11));
    builder.registerTransition(new MmuTransition(ASSIGN_11, ASSIGN_12));
    builder.registerTransition(new MmuTransition(ASSIGN_12, ASSIGN_13));
    builder.registerTransition(new MmuTransition(ASSIGN_13, ASSIGN_14));
    builder.registerTransition(new MmuTransition(ASSIGN_14, ASSIGN_15));
    builder.registerTransition(new MmuTransition(ASSIGN_15, ASSIGN_16));
    builder.registerTransition(new MmuTransition(ASSIGN_16, ASSIGN_17));
    builder.registerTransition(new MmuTransition(ASSIGN_17, ASSIGN_18));
    builder.registerTransition(new MmuTransition(ASSIGN_18, JOIN_1));
    builder.registerTransition(new MmuTransition(JOIN_1, JOIN_2));
    builder.registerTransition(new MmuTransition(BRANCH_2, BRANCH_6, new MmuGuard(MmuConditionAtom.neq(c.field(0, 1), new BigInteger("3", 10)))));
    builder.registerTransition(new MmuTransition(BRANCH_6, ASSIGN_19));
    builder.registerTransition(new MmuTransition(ASSIGN_19, ASSIGN_20));
    builder.registerTransition(new MmuTransition(ASSIGN_20, ASSIGN_21));
    builder.registerTransition(new MmuTransition(ASSIGN_21, ASSIGN_22));
    builder.registerTransition(new MmuTransition(ASSIGN_22, ASSIGN_23));
    builder.registerTransition(new MmuTransition(ASSIGN_23, JOIN_2));
    builder.registerTransition(new MmuTransition(JOIN_2, JOIN_0));
    builder.registerTransition(new MmuTransition(JOIN_0, JOIN_3));
    builder.registerTransition(new MmuTransition(ASSIGN_1, BRANCH_7, new MmuGuard(MmuConditionAtom.eq(c.field(0, 1), new BigInteger("2", 10)))));
    builder.registerTransition(new MmuTransition(BRANCH_7, ASSIGN_24));
    builder.registerTransition(new MmuTransition(ASSIGN_24, JOIN_3));
    builder.registerTransition(new MmuTransition(JOIN_3, STOP));
    builder.registerTransition(new MmuTransition(START, IF_WRITE, new MmuGuard(MemoryOperation.STORE)));
    builder.registerTransition(new MmuTransition(IF_WRITE, ASSIGN_25));
    builder.registerTransition(new MmuTransition(ASSIGN_25, ASSIGN_26));
    builder.registerTransition(new MmuTransition(ASSIGN_26, BRANCH_8, new MmuGuard(MmuConditionAtom.neq(c.field(0, 1), new BigInteger("2", 10)))));
    builder.registerTransition(new MmuTransition(BRANCH_8, BRANCH_9, new MmuGuard(L1.get(), BufferAccessEvent.HIT)));
    builder.registerTransition(new MmuTransition(BRANCH_9, ASSIGN_27));
    builder.registerTransition(new MmuTransition(ASSIGN_27, ASSIGN_28));
    builder.registerTransition(new MmuTransition(ASSIGN_28, ASSIGN_29));
    builder.registerTransition(new MmuTransition(ASSIGN_29, JOIN_4));
    builder.registerTransition(new MmuTransition(BRANCH_8, BRANCH_10, new MmuGuard(L1.get(), BufferAccessEvent.MISS)));
    builder.registerTransition(new MmuTransition(BRANCH_10, BRANCH_11, new MmuGuard(MmuConditionAtom.eq(c.field(0, 1), new BigInteger("3", 10)))));
    builder.registerTransition(new MmuTransition(BRANCH_11, BRANCH_12, new MmuGuard(L2.get(), BufferAccessEvent.HIT)));
    builder.registerTransition(new MmuTransition(BRANCH_12, ASSIGN_30));
    builder.registerTransition(new MmuTransition(ASSIGN_30, ASSIGN_31));
    builder.registerTransition(new MmuTransition(ASSIGN_31, ASSIGN_32));
    builder.registerTransition(new MmuTransition(ASSIGN_32, ASSIGN_33));
    builder.registerTransition(new MmuTransition(ASSIGN_33, ASSIGN_34));
    builder.registerTransition(new MmuTransition(ASSIGN_34, ASSIGN_35));
    builder.registerTransition(new MmuTransition(ASSIGN_35, ASSIGN_36));
    builder.registerTransition(new MmuTransition(ASSIGN_36, JOIN_5));
    builder.registerTransition(new MmuTransition(BRANCH_11, BRANCH_13, new MmuGuard(L2.get(), BufferAccessEvent.MISS)));
    builder.registerTransition(new MmuTransition(BRANCH_13, ASSIGN_37));
    builder.registerTransition(new MmuTransition(ASSIGN_37, ASSIGN_38));
    builder.registerTransition(new MmuTransition(ASSIGN_38, ASSIGN_39));
    builder.registerTransition(new MmuTransition(ASSIGN_39, ASSIGN_40));
    builder.registerTransition(new MmuTransition(ASSIGN_40, ASSIGN_41));
    builder.registerTransition(new MmuTransition(ASSIGN_41, ASSIGN_42));
    builder.registerTransition(new MmuTransition(ASSIGN_42, ASSIGN_43));
    builder.registerTransition(new MmuTransition(ASSIGN_43, ASSIGN_44));
    builder.registerTransition(new MmuTransition(ASSIGN_44, ASSIGN_45));
    builder.registerTransition(new MmuTransition(ASSIGN_45, ASSIGN_46));
    builder.registerTransition(new MmuTransition(ASSIGN_46, JOIN_5));
    builder.registerTransition(new MmuTransition(JOIN_5, JOIN_6));
    builder.registerTransition(new MmuTransition(BRANCH_10, BRANCH_14, new MmuGuard(MmuConditionAtom.neq(c.field(0, 1), new BigInteger("3", 10)))));
    builder.registerTransition(new MmuTransition(BRANCH_14, ASSIGN_47));
    builder.registerTransition(new MmuTransition(ASSIGN_47, ASSIGN_48));
    builder.registerTransition(new MmuTransition(ASSIGN_48, ASSIGN_49));
    builder.registerTransition(new MmuTransition(ASSIGN_49, ASSIGN_50));
    builder.registerTransition(new MmuTransition(ASSIGN_50, ASSIGN_51));
    builder.registerTransition(new MmuTransition(ASSIGN_51, ASSIGN_52));
    builder.registerTransition(new MmuTransition(ASSIGN_52, JOIN_6));
    builder.registerTransition(new MmuTransition(JOIN_6, JOIN_4));
    builder.registerTransition(new MmuTransition(JOIN_4, JOIN_7));
    builder.registerTransition(new MmuTransition(ASSIGN_26, BRANCH_15, new MmuGuard(MmuConditionAtom.eq(c.field(0, 1), new BigInteger("2", 10)))));
    builder.registerTransition(new MmuTransition(BRANCH_15, ASSIGN_53));
    builder.registerTransition(new MmuTransition(ASSIGN_53, ASSIGN_54));
    builder.registerTransition(new MmuTransition(ASSIGN_54, JOIN_7));
    builder.registerTransition(new MmuTransition(JOIN_7, STOP));
  }
}
